/*************************************************  Filter Functions Header  **************************************************

	Red Rapids
	797 N Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright (c) 2019  Red Rapids, Inc.

	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
	modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
	is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
	LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
	IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*************************************************  Filter Functions Header  **************************************************/

#ifndef _FILTER_FUNCTIONS_H_
#define _FILTER_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

#define FilterTypes 3
extern unsigned Filter[FilterTypes][6];

// Prototypes for each of the filter functions.
int FilterCoefficients(s_Handle *p_HW, unsigned ChannelNumber, unsigned Select, unsigned Type, unsigned *Coefficients);
int FilterConfigure(s_Handle *p_HW, unsigned ChannelNumber, unsigned Select, char *p_File);
unsigned FilterCount(s_Handle *p_HW, unsigned ChannelNumber);
void FilterFilename(s_Handle *p_HW, unsigned ChannelNumber, unsigned Select, char *p_File);
int FilterGain(s_Handle *p_HW, unsigned ChannelNumber, unsigned Select, unsigned Type, unsigned Log2Gain);
unsigned FilterKeyword(char *Keyword);
int FilterParser(unsigned Type, unsigned *Coefficients, unsigned *p_Log2Gain, unsigned *p_Resample, char *p_File);
int FilterResampler(s_Handle *p_HW, unsigned ChannelNumber, unsigned Select, unsigned Type, unsigned Resample);
unsigned FilterType(s_Handle *p_HW, unsigned ChannelNumber, unsigned Select);

#ifdef __cplusplus
}
#endif

#endif
