/*************************************************  Utility Functions Header  **************************************************

	Red Rapids
	797 N Grove Rd
	Suite 101
	Richardson, TX 75081
	www.redrapids.com | support@redrapids.com

	Copyright (c) 2019  Red Rapids, Inc.

	Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
	modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
	is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
	LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
	IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

*************************************************  Utility Functions Header  **************************************************/

#ifndef _UTILITY_FUNCTIONS_H_
#define _UTILITY_FUNCTIONS_H_

#if defined(__cplusplus)
	extern "C" {
#endif

// Prototypes for each of the utility functions.
unsigned ChannelState(s_Handle *p_HW, unsigned ChannelNumber);
void ClearLatency(s_Handle *p_HW);
int DataFile(char *p_File, unsigned PageSize, double FsDivisor, unsigned DataItemSize);
int DataLoad(char *p_File, void **p_Address, unsigned PageSize, unsigned NumPages, unsigned DataItemSize);
int DataSave(char *p_File, void **p_Address, s_Channel RXChannel, s_TODSettings TODClock, unsigned PageSize, unsigned NumPages, unsigned PacketInfo);
unsigned FIFOResidue(s_Handle *p_HW, unsigned ChannelNumber);
int FreeResources(s_Handle *p_HW, s_Channel *Channel, unsigned ChannelCount, s_UIOScan UIO);
float InterruptResponse(s_Handle *p_HW);
void InterruptTimeout(s_Handle *p_HW, unsigned IntTimeout);
void PciBenchmark(s_Handle *p_HW);
void PciPerformance(s_Handle *p_HW, float *p_Performance);
int ProbeSave(char *p_File, s_Handle *p_HW, unsigned ChannelNumber);
void ProcessChannels(s_Handle *p_HW);
void UserInit(s_Handle *p_HW, s_User *p_User);

#ifdef __cplusplus
}
#endif

#endif
